## zxing-cpp 2.3.0

=== debian/changelog ===
zxing-cpp (2.3.0-5) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.7.3.
  * debian/tests/control: Manually write python-based autopkgtest
    instead of relying on autodep8 for autopkgtest generation since
    this package is only built against the default python3 version,
    not all supported python3 version.
  * debian/tests/autopkgtest-pkg-python.conf: Deleted accordingly.

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1123686)
    + Multiarchify Python Build-Depends.
    + Export sysconfig data for cross compilation.

 -- Boyuan Yang <byang@debian.org>  Thu, 05 Feb 2026 12:36:05 -0500

zxing-cpp (2.3.0-4) unstable; urgency=medium

  * debian/patches/backport/: Cherry-pick upstream-suggested patches
    and prepare for Debian 13 release:
     - backport/3adaebc1a8a198d1e3b8eed169621a03d81cf387.patch
     - backport/82806f5f92173b8cb4e1e9bee13a2d07a33fb69f.patch
     - backport/93175e071d1719c44c0ad1193539141eb846999f.patch
     - backport/f3e36d0297d434a9c4b87035583760afda953360.patch
     - backport/ba3b61feb918a2371b2a991e759bde7c380b6a23.patch
     - backport/68c5727ba30bccf93056f8d19ba9cfc55994f2b5.patch
     - backport/36495ef0358c3d56d2e06e8a8ffdaac6afafcdb8.patch
     - backport/b46534d9bca0ce1832ee192c80e7395b999341b7.patch
     - backport/f45c1f0b4bf48c80fb7fb6ce42c7457eba379013.patch
     - 0010-Disable-test-unit-aztec-AZDecoderTest.cpp.patch:
       Needed to incorporate fuzzy patches.
    Note that test changes in some patches are dropped to handle
    fuzzy patches.
  * debian/rules: Drop definition of NDEBUG macro since the proper
    fix has been merged in the patches.

 -- Boyuan Yang <byang@debian.org>  Wed, 30 Apr 2025 14:07:19 -0400

zxing-cpp (2.3.0-3) unstable; urgency=medium

  * debian/rules: Define NDEBUG macro for now to circumvent upstream
    abuse of NDEBUG macro in 2.3.0 release. (Closes: #1095196)

 -- Boyuan Yang <byang@debian.org>  Fri, 07 Feb 2025 15:47:30 -0500

zxing-cpp (2.3.0-2) unstable; urgency=medium

  * debian/rules: Enable building C API as suggested upstream.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Jan 2025 19:51:36 -0500

zxing-cpp (2.3.0-1) unstable; urgency=medium

  * New upstream release 2.3.0.
  * debian/patches/: Drop all old patches, merged upstream.
  * debian/rules:
    + Update all CMake option names.
    + Add option to use system zint by default.
  * debian/copyright: Update Files-Excluded pattern and copyright info.

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Jan 2025 09:54:35 -0500
