=== debian/control ===
Source: zxing-cpp
Section: libs
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 cmake (>= 3.16),
 debhelper-compat (= 13),
 dh-sequence-python3,
 libfmt-dev <!nocheck>,
 libgmock-dev <!nocheck>,
 libgtest-dev <!nocheck>,
 libpython3-dev,
 libstb-dev,
 pkgconf,
 pybind11-dev,
 python3-dev:native,
 python3-numpy <!nocheck>,
 python3-opencv <!nocheck>,
 python3-pil <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/zxing-cpp/zxing-cpp
Vcs-Git: https://salsa.debian.org/debian/zxing-cpp.git
Vcs-Browser: https://salsa.debian.org/debian/zxing-cpp
Description: C++ port of ZXing library
 ZXing-C++ ("zebra crossing") is an open-source, multi-format 1D/2D
 barcode image processing library implemented in C++.
 .
 It was originally ported from the Java ZXing library but has been
 developed further and now includes many improvements in terms of
 quality and performance. It can both read and write barcodes in a
 number of formats:  QR Code, DataMatrix, Aztec, PDF417, UPC-A, UPC-E,
 EAN-8, EAN-13, DataBar/RSS, Code 39, Code 93, Code 128, Codabar, ITF.

Package: libzxing-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libzxing3 (= ${binary:Version}),
 ${misc:Depends},
Replaces:
 libzxingcore-dev (<< 1.3.0~),
Breaks:
 libzxingcore-dev (<< 1.3.0~),
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides development files for zxing-cpp library.

Package: libzxing3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (library files)
 ${source:Extended-Description}
 .
 This package provides library files for zxing-cpp library.

Package: python3-zxing-cpp
Architecture: any
Section: python
Depends:
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (python3 binding)
 ${source:Extended-Description}
 .
 This package provides python3 binding for zxing-cpp library.

Package: zxing-cpp-tools
Architecture: any
Section: utils
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Utilities provided by ZXing library
 ${source:Extended-Description}
 .
 This package provides various example utilities written with zxing-cpp
 library.
