=== debian/tests/control ===
# Manually specify autopkgtest instead of autodep8
# due to the package only supporting py3versions -d
# instead of py3versions -s or py3versions -r.
#
Test-Command: set -e ; for py in $(py3versions -d 2>/dev/null) ; do cd "$AUTOPKGTEST_TMP" ; echo "Testing with $py:" ; $py -c "import zxingcpp; print(zxingcpp)" ; done
Depends: python3, python3-zxing-cpp
Restrictions: allow-stderr, superficial
Features: test-name=autodep8-python3
