=== debian/changelog ===
zxing-cpp (3.0.0~rc1+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
    + Repack the tarball to include zint/2.16.0 source code as MUT
      component as suggested upstream.
  * debian/watch: Update to version 5 and add the zint component.
  * debian/copyright: Add information from zint component.
  * debian/: Bump library SONAME to 4.
  * debian/rules: Update build flags following upstream suggestion.
  * debian/control: Build-depends on system libpng-dev.

 -- Boyuan Yang <byang@debian.org>  Thu, 05 Feb 2026 14:45:34 -0500
