=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: zxing-cpp
 Section: libs
-Priority: optional
 Maintainer: Boyuan Yang <byang@debian.org>
 Build-Depends:
  cmake (>= 3.16),
@@ -10,15 +9,16 @@
  libgmock-dev <!nocheck>,
  libgtest-dev <!nocheck>,
  libpython3-dev,
+ libpng-dev,
  libstb-dev,
+# libzint-dev (>= 2.16),
  pkgconf,
  pybind11-dev,
  python3-dev:native,
  python3-numpy <!nocheck>,
  python3-opencv <!nocheck>,
  python3-pil <!nocheck>,
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://github.com/zxing-cpp/zxing-cpp
 Vcs-Git: https://salsa.debian.org/debian/zxing-cpp.git
 Vcs-Browser: https://salsa.debian.org/debian/zxing-cpp
@@ -37,7 +37,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libzxing3 (= ${binary:Version}),
+ libzxing4 (= ${binary:Version}),
  ${misc:Depends},
 Replaces:
  libzxingcore-dev (<< 1.3.0~),
@@ -48,7 +48,7 @@
  .
  This package provides development files for zxing-cpp library.
 
-Package: libzxing3
+Package: libzxing4
 Architecture: any
 Multi-Arch: same
 Depends:
