## zxing-cpp 3.0.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,8 @@
 option (ZXING_EXAMPLES "Build the example barcode reader/writer applications" ON)
 option (ZXING_BLACKBOX_TESTS "Build the black box reader/writer tests" OFF)
 option (ZXING_UNIT_TESTS "Build the unit tests (don't enable for production builds)" OFF)
-option (ZXING_INSTALL_TEST "Test if the installed/public API works" OFF)
+option (ZXING_TEST_DOTNET "Test if the .NET wrapper works" OFF)
+option (ZXING_TEST_INSTALL "Test if the installed/public API works" OFF)
 option (ZXING_PYTHON_MODULE "Build the python module" OFF)
 set    (ZXING_DEPENDENCIES "AUTO" CACHE STRING "Fetch from github or use locally installed (AUTO/GITHUB/LOCAL)")
 option (ZXING_CLANG_TIDY "Enable clang-tidy analysis" OFF)
@@ -70,13 +71,9 @@
 endif()
 
 # make installed binaries relocatable on macOS and Linux
+set(CMAKE_BUILD_RPATH_USE_ORIGIN ON)  # improve build reproducibility
 set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
-if(APPLE)
-    set(CMAKE_MACOSX_RPATH ON) # make the binar
-    set(CMAKE_INSTALL_RPATH "@loader_path/../lib")
-elseif(UNIX)
-    set(CMAKE_INSTALL_RPATH "$ORIGIN/../lib")
-endif()
+set(CMAKE_INSTALL_RPATH "$<$<PLATFORM_ID:Darwin>:@loader_path/../lib>$<$<PLATFORM_ID:Linux>:$ORIGIN/../lib>")
 
 add_subdirectory (core)
 
@@ -94,7 +91,10 @@
 if (ZXING_UNIT_TESTS)
     add_subdirectory (test/unit)
 endif()
-if (ZXING_INSTALL_TEST)
+if (ZXING_TEST_DOTNET)
+    add_subdirectory (wrappers/dotnet)
+endif()
+if (ZXING_TEST_INSTALL)
     add_test(
         NAME InstallTest
         COMMAND
