=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 project (ZXing VERSION "3.0.0")
-set (ZXING_VERSION_SUFFIX "-rc1")
+set (ZXING_VERSION_SUFFIX "")
 set (ZXING_SONAME 4) # see https://github.com/zxing-cpp/zxing-cpp/issues/333
 
 option (ZXING_USE_BUNDLED_ZINT "Use the bundled libzint for barcode creation/writing" ON)
@@ -47,19 +47,13 @@
 
 set (ZXING_USE_ZINT ${ZXING_WRITERS_NEW}) # see Version.h.in
 
-set (ZXING_PUBLIC_FLAGS
-    $<$<CXX_COMPILER_ID:MSVC>:/Zc:__cplusplus>
-)
-
 set (ZXING_PRIVATE_FLAGS
     -DZXING_INTERNAL
     $<$<BOOL:${ZXING_UNIT_TESTS}>:-DZXING_BUILD_FOR_TEST>
 )
 
 if (WINRT)
-    list (APPEND ZXING_PUBLIC_FLAGS
-        -DWINRT
-    )
+    set (ZXING_PUBLIC_FLAGS -DWINRT )
 endif()
 
 if (MSVC)
@@ -133,6 +127,7 @@
     src/WriteBarcode.cpp
     src/ZXingCpp.h
     src/ZXingCpp.cpp
+    src/ZXingQt.h
     src/ZXAlgorithms.h
     src/ZXConfig.h
     src/ZXTestSupport.h
@@ -227,6 +222,7 @@
     src/ReaderOptions.h
     src/WriteBarcode.h
     src/ZXingCpp.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingQt.h
     $<$<BOOL:${ZXING_C_API}>:${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingC.h>
 )
 if (ZXING_READERS)
@@ -425,3 +421,5 @@
         src/pdf417/PDFEncoder.h
         src/pdf417/PDFEncoder.cpp
         src/pdf417/PDFHighLevelEncoder.h
+        src/pdf417/PDFHighLevelEncoder.cpp
+        src/pdf417/PDFWriter.h
