=== debian/changelog ===
zxing-cpp (3.0.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control: Drop unnecessary versioned dep.
  * debian/gbp.conf: Properly add zint component.

 -- Boyuan Yang <byang@debian.org>  Tue, 10 Feb 2026 13:33:28 -0500

zxing-cpp (3.0.0~rc1+ds-1~exp2) experimental; urgency=medium

  * debian/patches/backport/: Backport upstream trunk commits.
  * debian/control: Drop unnecessary (test-)build-dep libgtest-dev,
    libgmock-dev.
  * debian/control: Drop unnecessary build-dep libpng-dev, libfmt-dev.
  * debian/control: Add Qt6 build-deps to enable Qt6-based wrapper
    building.
  * debian/control: Update package description following upstream
    suggestion.

 -- Boyuan Yang <byang@debian.org>  Fri, 06 Feb 2026 09:41:27 -0500
