=== debian/rules ===
--- 
+++ 
@@ -41,6 +41,7 @@
 	        -DZXING_PYTHON_MODULE=ON             \
 	        -DZXING_C_API=ON                     \
 	        -DZXING_WRITERS=BOTH                 \
+	        -DZXING_EXAMPLES=ON                  \
 	        -DZXING_USE_BUNDLED_ZINT=ON          \
 	        -DZXING_DEPENDENCIES=LOCAL           \
 	        -DPYTHON_EXECUTABLE:FILEPATH=$(shell command -v $$(py3versions -d))
