## zxing-cpp 3.0.1%2Bds

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-project (ZXing VERSION "3.0.0")
+project (ZXing VERSION "3.0.1")
 set (ZXING_VERSION_SUFFIX "")
 set (ZXING_SONAME 4) # see https://github.com/zxing-cpp/zxing-cpp/issues/333
 
@@ -131,6 +131,7 @@
     src/ZXAlgorithms.h
     src/ZXConfig.h
     src/ZXTestSupport.h
+    src/ZXVersion.h
     $<$<BOOL:${ZXING_C_API}>:src/ZXingC.h>
     $<$<BOOL:${ZXING_C_API}>:src/ZXingC.cpp>
 )
@@ -222,6 +223,7 @@
     src/ReaderOptions.h
     src/WriteBarcode.h
     src/ZXingCpp.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/ZXVersion.h # deprecated, but keep it for now to not break old clients
     ${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingQt.h
     $<$<BOOL:${ZXING_C_API}>:${CMAKE_CURRENT_SOURCE_DIR}/src/ZXingC.h>
 )
@@ -419,7 +421,3 @@
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFCompaction.h
         src/pdf417/PDFEncoder.h
-        src/pdf417/PDFEncoder.cpp
-        src/pdf417/PDFHighLevelEncoder.h
-        src/pdf417/PDFHighLevelEncoder.cpp
-        src/pdf417/PDFWriter.h
