=== debian/changelog ===
zxing-cpp (3.0.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/rules: Enable ZXING_EXAMPLE_QT build flag.

 -- Boyuan Yang <byang@debian.org>  Thu, 12 Feb 2026 11:03:36 -0500

zxing-cpp (3.0.0+ds-1~exp2) experimental; urgency=medium

  * debian/patches/backport/6c953c6f0b9893fdbec5e3f9d510b4e06ccd2265.patch:
    Add patch from upstream trunk on libreoffice compatibility fix.

 -- Boyuan Yang <byang@debian.org>  Tue, 10 Feb 2026 20:02:06 -0500
