=== debian/watch ===
Version: 5

Template: GitHub
Owner: zxing-cpp
Project: zxing-cpp
Uversionmangle: s/-rc/~rc/
Repacksuffix: +ds
Dversion-Mangle: auto

Component: zint
Template: GitHub
Owner: zint
Project: zint
Version-Schema: ignore
