## zxing-cpp 3.0.2%2Bds

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-project (ZXing VERSION "3.0.1")
+project (ZXing VERSION "3.0.2")
 set (ZXING_VERSION_SUFFIX "")
 set (ZXING_SONAME 4) # see https://github.com/zxing-cpp/zxing-cpp/issues/333
 
@@ -81,7 +81,7 @@
     list (APPEND ZXING_PRIVATE_FLAGS "${FILE_PREFIX_ARG}")
 endif()
 
-################# Source files
+# MARK: - COMMON_FILES
 
 set (COMMON_FILES
     src/Barcode.h
@@ -207,6 +207,8 @@
     )
 endif()
 
+# MARK: - PUBLIC_HEADERS
+
 # define subset of public headers that get distributed with the binaries
 set (PUBLIC_HEADERS
     src/Barcode.h
@@ -240,6 +242,8 @@
     )
 endif()
 # end of public header set
+
+# MARK: - READERS/WRITERS
 
 if (ZXING_READERS AND ZXING_ENABLE_AZTEC)
     set (AZTEC_FILES ${AZTEC_FILES}
@@ -420,4 +424,3 @@
 if (ZXING_WRITERS_OLD AND ZXING_ENABLE_PDF417)
     set (PDF417_FILES ${PDF417_FILES}
         src/pdf417/PDFCompaction.h
-        src/pdf417/PDFEncoder.h
